import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.MediaTracker;
import java.net.MalformedURLException;
import java.net.URL;

/**
 * @author dknowles
 */
public class ImageApplet extends Applet
{
    Image image = null ;

    public static void main(String[] args)
    {
    }
    /* (non-Javadoc)
     * @see java.applet.Applet#init()
     */
    public void init()
    {
        super.init();
//        image = getImageData ( "images/Test.jpg" ) ;
        image = getImageData ( "" ) ;
        repaint ( ) ;
    }

    /* (non-Javadoc)
     * @see java.awt.Component#paintAll(java.awt.Graphics)
     */
    public void paint(Graphics g)
    {
        super.paint ( g ) ;
        if ( image != null )
        {
            g.drawImage ( image, 0, 0, this ) ;
        }
    }


    /**
        * This function gets the image specified by the input URL.
        * It WILL wait for the image to be loaded.
        * @param urlName String name of the URL.
        * @return Image which has been loaded or null if an error occurred.
    */
    public Image getImageData ( String urlName )
    {
        Image image = null ;
        try
        {
            image = getImage(new URL(getCodeBase(), urlName)) ;
            waitForImage ( image ) ;
        }
        catch (MalformedURLException err)
        {
            System.out.println ( "Malformed URL: " + urlName ) ;
            image = null ;
        }
        return image ;
    }


    /**
        * This function waits for the specified image to load.
        * @param image Image to wait for.
    */
    public void waitForImage ( Image image )
    {
        MediaTracker tracker = new MediaTracker ( this ) ;
        tracker.addImage ( image, 0 ) ;
        try
        {
            tracker.waitForID(0);
        } catch ( Exception e ) {}
    }

}
